



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Android数据加密之MD5加密</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Android数据加密之MD5加密</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-02 10:21:32 </span>
						</div>
										<div class="post-content">
											
		<h3>前言：</h3>
<p>项目中无论是密码的存储或者说判断文件是否是同一文件，都会用到MD5算法，今天来总结一下MD5加密算法。</p>
<h3>什么是MD5加密？</h3>
<p>MD5英文全称&ldquo;Message-Digest Algorithm 5&rdquo;，翻译过来是&ldquo;消息摘要算法5&rdquo;，由MD2、MD3、MD4演变过来的，是一种单向加密算法，是不可逆的一种的加密方式。</p>
<p>其他几种加密方式：</p>
<ul><li><p><a href="http://www.cnblogs.com/whoislcj/p/5470095.html" rel="external nofollow noreferrer">Android数据加密之Rsa加密</a></p></li>
<li><p><a href="http://www.cnblogs.com/whoislcj/p/5473030.html" rel="external nofollow noreferrer">Android数据加密之Aes加密</a></p></li>
<li><p><a href="http://www.cnblogs.com/whoislcj/p/5580950.html" rel="external nofollow noreferrer">Android数据加密之Des加密</a></p></li>
<li><p><a href="http://www.cnblogs.com/whoislcj/p/5885006.html" rel="external nofollow noreferrer">Android数据加密之MD5加密</a></p></li>
<li><p><a href="http://www.cnblogs.com/whoislcj/p/5887859.html" rel="external nofollow noreferrer">Android数据加密之Base64编码算法</a></p></li>
<li><p><a href="http://www.cnblogs.com/whoislcj/p/5944917.html" rel="external nofollow noreferrer">Android数据加密之异或加密算法</a></p></li></ul>
<h3>MD5加密有哪些特点？</h3>
<ul><li><p>压缩性：任意长度的数据，算出的MD5值长度都是固定的。</p></li>
<li><p>容易计算：从原数据计算出MD5值很容易。</p></li>
<li><p>抗修改性：对原数据进行任何改动，哪怕只修改1个字节，所得到的MD5值都有很大区别。</p></li>
<li><p>强抗碰撞：已知原数据和其MD5值，想找到一个具有相同MD5值的数据（即伪造数据）是非常困难的。</p></li></ul>
<h3>MD5应用场景：</h3>
<ul><li><p>一致性验证</p></li>
<li><p>数字签名</p></li>
<li><p>安全访问认证</p></li></ul>
<h3>MD5加密算法实现：</h3>
<h4>1.）计算字符串MD5值</h4>
<div>
<pre class="prettyprint linenums">    public static String md5(String string) {<br />
        if (TextUtils.isEmpty(string)) {<br />
            return "";<br />
        }<br />
        MessageDigest md5 = null;<br />
        try {<br />
            md5 = MessageDigest.getInstance("MD5");<br />
            byte[] bytes = md5.digest(string.getBytes());<br />
            String result = "";<br />
            for (byte b : bytes) {<br />
                String temp = Integer.toHexString(b &amp; 0xff);<br />
                if (temp.length() == 1) {<br />
                    temp = "0" + temp;<br />
                }<br />
                result += temp;<br />
            }<br />
            return result;<br />
        } catch (NoSuchAlgorithmException e) {<br />
            e.printStackTrace();<br />
        }<br />
        return "";<br />
    }</pre>
</div>
<h4>2.）计算文件的MD5值</h4>
<div>
<pre class="prettyprint linenums"> // 计算文件的 MD5 值<br />
    public static String md5(File file) {<br />
        if (file == null || !file.isFile() || !file.exists()) {<br />
            return "";<br />
        }<br />
        FileInputStream in = null;<br />
        String result = "";<br />
        byte buffer[] = new byte[8192];<br />
        int len;<br />
        try {<br />
            MessageDigest md5 = MessageDigest.getInstance("MD5");<br />
            in = new FileInputStream(file);<br />
            while ((len = in.read(buffer)) != -1) {<br />
                md5.update(buffer, 0, len);<br />
            }<br />
            byte[] bytes = md5.digest();

            for (byte b : bytes) {<br />
                String temp = Integer.toHexString(b &amp; 0xff);<br />
                if (temp.length() == 1) {<br />
                    temp = "0" + temp;<br />
                }<br />
                result += temp;<br />
            }<br />
        } catch (Exception e) {<br />
            e.printStackTrace();<br />
        }finally {<br />
            if(null!=in){<br />
                try {<br />
                    in.close();<br />
                } catch (IOException e) {<br />
                    e.printStackTrace();<br />
                }<br />
            }<br />
        }<br />
        return result;<br />
    }</pre>
</div>
<p>或者采用nio的方式</p>
<div>
<pre class="prettyprint linenums">   public static String md5(File file) {<br />
        String result = "";<br />
        FileInputStream in = null;<br />
        try {<br />
            in = new FileInputStream(file);<br />
            MappedByteBuffer byteBuffer = in.getChannel().map(FileChannel.MapMode.READ_ONLY, 0, file.length());<br />
            MessageDigest md5 = MessageDigest.getInstance("MD5");<br />
            md5.update(byteBuffer);<br />
            byte[] bytes = md5.digest();<br />
            for (byte b : bytes) {<br />
                String temp = Integer.toHexString(b &amp; 0xff);<br />
                if (temp.length() == 1) {<br />
                    temp = "0" + temp;<br />
                }<br />
                result += temp;<br />
            }<br />
        } catch (Exception e) {<br />
            e.printStackTrace();<br />
        } finally {<br />
            if (null != in) {<br />
                try {<br />
                    in.close();<br />
                } catch (IOException e) {<br />
                    e.printStackTrace();<br />
                }<br />
            }<br />
        }<br />
        return result;<br />
    }</pre>
</div>
<h3>MD5加密安全性探讨：</h3>
<p>虽然说MD5加密本身是不可逆的，但并不是不可破译的，网上有关MD5解密的网站数不胜数，破解机制采用穷举法，就是我们平时说的跑字典。所以如何才能加大MD5破解的难度呢？</p>
<h4>1.）对字符串多次MD5加密</h4>
<div>
<pre class="prettyprint linenums">    public static String md5(String string, int times) {<br />
        if (TextUtils.isEmpty(string)) {<br />
            return "";<br />
        }<br />
        String md5 = md5(string);<br />
        for (int i = 0; i &lt; times - 1; i++) {<br />
            md5 = md5(md5);<br />
        }<br />
        return md5(md5);<br />
    }</pre>
</div>
<h4>2.）MD5加盐</h4>
<p>加盐的方式也是多种多样</p>
<ul><li><p>string+key（盐值key）然后进行MD5加密</p></li>
<li>用string明文的hashcode作为盐，然后进行MD5加密</li>
<li><p>随机生成一串字符串作为盐，然后进行MD5加密</p></li></ul>
<div>
<pre class="prettyprint linenums">    public static String md5(String string, String slat) {<br />
        if (TextUtils.isEmpty(string)) {<br />
            return "";<br />
        }<br />
        MessageDigest md5 = null;<br />
        try {<br />
            md5 = MessageDigest.getInstance("MD5");<br />
            byte[] bytes = md5.digest((string + slat).getBytes());<br />
            String result = "";<br />
            for (byte b : bytes) {<br />
                String temp = Integer.toHexString(b &amp; 0xff);<br />
                if (temp.length() == 1) {<br />
                    temp = "0" + temp;<br />
                }<br />
                result += temp;<br />
            }<br />
            return result;<br />
        } catch (NoSuchAlgorithmException e) {<br />
            e.printStackTrace();<br />
        }<br />
        return "";<br />
    }</pre>
</div>
<h3>总结：</h3>
<p>MD5加密简单的总结到此为止。</p>																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8knj0j8.html">【Git学习笔记】撤销修改</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq1p5x4q.html">Oracle merge into</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ok4gmx9.html">Knockout&period;Js官网学习（event绑定、submit绑定）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnpnd2q.html">KMP算法具体解释&lpar;转&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdemjk8.html">&lbrack;转贴&rsqb; 从零开始学C&plus;&plus;之异常（二）：程序错误、异常（语法、抛出、捕获、传播）、栈展开</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zgzy09.html">Objective-c 类实现 （&commat;implementation）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjxe138.html">Servlet--Servlet接口</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjmzvr8.html">Tomcat的缺省是多少，怎么修改</a>
		</li>
						<li><a href="https://www.batexi.com/a/93y46wg8.html">CSS入门知识汇总</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvgxwx8.html">mySQL 判断表是否存</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnv03mg8.html">自学Zabbix3&period;12&period;3-动作Action-自动发现action配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/960ww4j9.html">BZOJ 1232 安慰奶牛题解</a>
		</li>
						<li><a href="https://www.batexi.com/a/960ej4n9.html">linux150条命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mjd2wo8.html">Flickr Hosts</a>
		</li>
						<li><a href="https://www.batexi.com/a/qx2ml5d8.html">黑马程序员【JSP九大内置对象和四个作用域】转载</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyvz56mq.html">Selenium2&plus;python自动化-操作浏览器基本方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1v0v26q.html">「PLC」PLC基本编程</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdjmo37q.html">C&num; WebHelper-CookieHelper，CacheHelper，SessionHelper</a>
		</li>
						<li><a href="https://www.batexi.com/a/q77gkjxq.html">方便处理hosts的批处理脚本：hosts助手&period;bat</a>
		</li>
						<li><a href="https://www.batexi.com/a/q15ygw49.html">POJ 3667 线段树区间合并</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/kjqdw79d.html">【&period;net 深呼吸】序列化中的&OpenCurlyDoubleQuote;引用保留&rdquo;</a>
			</li>
						<li><a href="https://www.batexi.com/a/kwq1509g.html">可爱的豆子&mdash;&mdash;使用Beans思想让Python代码更易维护</a>
			</li>
						<li><a href="https://www.batexi.com/a/49gmvl97.html">SQL数据库之DQL</a>
			</li>
						<li><a href="https://www.batexi.com/a/4qn1rx8r.html">04&period;LoT&period;UI 前后台通用框架分解系列之&mdash;&mdash;轻巧的弹出框</a>
			</li>
						<li><a href="https://www.batexi.com/a/390md48d.html">JavaScript的继承实现方式</a>
			</li>
						<li><a href="https://www.batexi.com/a/49gjy797.html">ASP&period;NET Core 1&period;0 使用 Dapper 操作 MySql（包含事务）</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqdw7x9d.html">一个表缺失索引发的CPU资源瓶颈案例</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qyvnxqr.html">Windows下Visual studio 2013 编译 Audacity</a>
			</li>
						<li><a href="https://www.batexi.com/a/49g3gzq7.html">真假4K电视验证：一张图足矣</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8kne68j.html">关于MJRefresh的下拉加载数据bug</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
